import QtQuick 1.1

// rectangle for description texts
Rectangle {
    property alias text: textBox.text
    property alias continueVisible: continueIcon.visible
    property int innerWidth;
    signal clicked

    anchors.horizontalCenter: parent.horizontalCenter
    anchors.bottom: parent.bottom
    anchors.bottomMargin: 100
    width: textBox.width + 36
    height: textBox.height + 20
    border.color: "#333333"
    border.width: 5
    smooth: true
    opacity: 0.95
    color: "#333333"

    Image {
        id: continueIcon
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 5
        anchors.right: parent.right
        anchors.rightMargin: 5
        source: "qrc:/MO/gui/next"

        SequentialAnimation on opacity {
            loops: Animation.Infinite

            PauseAnimation { duration: 500 }
            PropertyAnimation { easing.type: Easing.InOutSine; duration: 400; to: 0.0 }
            PropertyAnimation { easing.type: Easing.OutInSine; duration: 400; to: 1.0 }
        }
    }

    Text {
        id: textBox
        text: ""
		color: "#f5f5f5"
        font.pointSize: 10.5
        font.bold: false
        width: innerWidth
        font.family: "Malgun Gothic, NanumGothic, Dotum, Arial"
        wrapMode: Text.WordWrap
        anchors.centerIn: parent
    }

    MouseArea {
        id: clickArea
        anchors.fill: parent
        onClicked: parent.clicked(mouse)
    }
}
