//TL Conflict Resolution#10
function getTutorialSteps() {
    return [
        function() {
            tutorial.text = qsTr("모드를 관리하면서 마주치게 될 충돌 양상에는 여러가지가 있습니다. 이 튜토리얼에서는 그러한 충돌 문제에 대처하는 방법을 안내할 것입니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("첫번째 충돌 유형은 \"중복파일 충돌 (File Conflicts)\"입니다. 이는 두 개 이상의 모드에 동일한 경로와 이름을 가진 파일이 포함되어 있을 때 발생합니다.\n대개 리텍스쳐 모드처럼 게임내의 동일한 부분을 대체/변경하는 모드가 다수 존재할 경우 중복파일 충돌이 일어나게 됩니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("예를 들자면, \"A 모드\"에서는 바닐라 게임의 철제 방어구와 가죽 방어구를 리텍하고, \"B 모드\"에서는 에보니 방어구와 역시 가죽 방어구를 리텍한다고 가정합시다.\n이러한 경우 당연히 충돌이 발생하게 됩니다. 가죽 방어구를 리텍할 모드로서 어떠한 모드를 사용하시겠습니까?")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("MO로 모드를 관리하지 않을 경우, (NMM 등의 툴에서는) \"B 모드\"를 설치할 때 이미 존재하는(중복되는) 가죽 방어구 부분을 덮어씌울지를 선택하게 됩니다. 이때 덮어쓰기를 선택하면 가죽 방어구는 \"B 모드\"로 적용되고, 그렇지 않으면 \"A 모드\"로 적용됩니다.\n차후에 이 선택을 변경하고자 한다면, A나 B 모드 중 하나를 재설치해야만 합니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("MO로 모드를 관리할 경우, A 모드와 B 모드는 각자의 파일을 그대로 온전히 보존한 채 설치될 수 있습니다. (다른 모드를 덮어씌울지의 선택 여부도 묻지 않습니다)\n그리고 기본적으로는 나중에 설치된 \"B 모드\"가 자동적으로 높은 우선순위를 가짐으로써 중복되는 가죽 방어구에 적용됩니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("최종 적용될 모드를 결정하는 이 우선순위는, 어느 때든 자유롭게 마우스 드래그&드랍을 통해서 모드 배열 순서를 변경함으로써 바꿀 수 있습니다.\n\"A 모드\"의 우선순위를 높게 설정하면, 번거로운 재설치 과정 없이 중복되는 가죽 방어구를 A 모드로 적용할 수 있게 됩니다.\n모드 배열 순서는 따로 조정하지 않을 경우 기본적으로 나중에 설치된 모드일수록 높은 우선순위를 갖습니다.")
            highlightItem("modList", false)
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("모드간에 서로 겹치는 중복파일이 존재할 경우, \"플래그\" 열에 번개 아이콘이 표시됨으로써 충돌 여부와 양상을 알 수 있습니다.\n번개 아이콘에는 더하기가 붙은 번개, 빼기가 붙은 번개, 더하기 빼기가 동시에 붙은 번개, 회색 번개의 4가지가 있습니다.")
            waitForClick()
        },
        function() {
            unhighlight()
            tutorial.text = qsTr("<img src=\":/MO/gui/emblem_conflict_overwrite\" /> 더하기 번개 아이콘은 이 모드가 다른 모드를 <b>일부</b> 덮어쓴다는 것을 의미합니다. 다른 모드의 우선순위가 더 낮은 경우입니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("<img src=\":/MO/gui/emblem_conflict_overwritten\" /> 빼기 번개 아이콘은 이 모드가 다른 모드에 의해 <b>일부</b> 덮어씌워진다는 것을 의미합니다. 다른 모드의 우선순위가 더 높은 경우입니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("<img src=\":/MO/gui/emblem_conflict_mixed\" /> 더하기빼기 번개 아이콘은 이 모드가 <b>일부</b>는 덮어쓰고, <b>일부</b>는 덮어씌워진다는 것을 의미합니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("<img src=\":/MO/gui/emblem_conflict_redundant\" /> 회색 번개 아이콘은 이 모드가 다른 모드에 의해 <b>완전히</b> 덮어씌워진다는 것을 의미합니다. 따라서 이 모드를 비활성화해도 무방합니다.");
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("서로 겹치는 중복파일을 하나하나 확인하는 방법에는 2가지가 있습니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("옵션 A: 오른쪽 패널의 \"Data\" 탭을 열어보세요.")
            if (!tutorialControl.waitForTabOpen("tabWidget", 2)) {
                highlightItem("tabWidget", false)
                waitForClick()
            } else {
                highlightItem("tabWidget", true)
            }
        },
        function() {
            tutorial.text = qsTr("\"Data\" 탭 하단의 \"서로 겹치는 중복파일만 보기\"에 체크하면, 가상 Data 폴더 내에 서로 겹치는 파일만 표시됩니다.\n목록의 오른쪽 줄에는 (우선순위가 높아) 최종 적용되는 모드 이름이 표시되고, 그 위에 마우스를 올리면 (툴팁을 통해) 덮어씌워진 다른 모드의 목록을 알 수 있습니다.")
            highlightItem("conflictsCheckBox", false)
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("옵션 B: 활성화된 모드 중 중복파일 정보를 알고자 하는 모드를 더블클릭하여 모드 정보창을 띄워보세요. 혹은 모드를 마우스 우클릭하여 <i>모드 정보 보기...</i>를 선택하셔도 됩니다.")
            highlightItem("modList", true)
            manager.activateTutorial("ModInfoDialog", "tutorial_conflictresolution_modinfo.js")
            applicationWindow.modInfoDisplayed.connect(nextStep)
        },
        function() {
            unhighlight()
            tutorial.text = qsTr("이것으로 중복파일 충돌에 대한 안내를 마칩니다.\n\n두번째로 다룰 충돌 유형은 \"플러그인 충돌 (Record Conflicts)\"입니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("\"First Steps\" 튜토리얼에서 언급했듯이, esp/esm 플러그인에는 무기/NPC/퀘스트/지역 등의 ID 값을 추가/변경하는 레코드가 담겨 있습니다.\n이는 단순히 텍스쳐/메쉬 파일을 대체하는 리텍 모드가 아닌, 플러그인 모드에서만 발생하는 충돌이므로 \"플러그인 충돌\"이라고 부릅니다.\n예를 들면 활성화된 두 개의 모드가 알두인의 체력을 각기 5000과 10000으로 변경할 경우, 두 변경은 당연히 동시에 적용될 수 없으며 실제로 게임에 적용되는 것은 우선순위가 높은 모드 하나뿐입니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("\"파일 충돌\" 때와 마찬가지로 \"플러그인 충돌\" 또한 충돌을 실제로 교정하는 것이 아니라, 최종 적용될 한쪽 모드를 선택하는 것으로 해결합니다.\n단 플러그인 충돌에서는 선택을 잘못하면 게임이 불안정해지거나 진행이 아예 불가능해질 수도 있습니다. 이는 모드의 레코드간에 종속관계가 있을 경우, (충돌로 인해) 어느 한쪽만 값이 바뀌면 양쪽 모두 제대로 기능하지 못하기 때문입니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("이제 오른쪽 패널에서 \"Plugins\" 탭을 열어주세요.")
            highlightItem("tabWidget", true)
            if (!tutorialControl.waitForTabOpen("tabWidget", 0)) {
                nextStep()
            }
        },
        function() {
            tutorial.text = qsTr("왼쪽 패널의 모드 목록과 마찬가지로, 플러그인 목록도 마우스 드래그&드랍으로 우선순위를 바꿀 수 있습니다. 이를 통해 플러그인 충돌에 대해 우선권을 갖게 되는 플러그인을 결정할 수 있습니다.\n이 \"플러그인 배열 순서\"는 통상 \"모드 배열 순서\"라고 불립니다. (Load order) MO에서는 모드 배열 순서와 플러그인 배열 순서는 다른 개념입니다.\n하지만 배열 순서를 결정하는 기준은 어떻게 알 수 있을까요?")
            waitForClick()
        },
        function() {
            unhighlight()
            tutorial.text = qsTr("파일 충돌과는 달리 플러그인 충돌에서는 MO가 레코드의 충돌 여부/양상을 표시해주지 않습니다. 때문에 정확히 어떤 레코드끼리 충돌이 일어나는지 알 수 없습니다.\n\n다행히도 플러그인을 자동으로 적절한 순서로 배열해 주는 \"BOSS\"라는 멋진 프로그램이 있습니다. BOSS는 넥서스에서 다운로드할 수 있으며, MO와도 말끔하게 호환됩니다.\n만약 아직 BOSS를 설치하지 않은 상태라면 설치하실 것을 권장합니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("BOSS가 설치 기본 경로대로 설치되면, MO를 재시작했을 때 오른쪽 상단의 실행 프로그램 목록에 BOSS가 자동으로 추가되어 있을 것입니다.\n만약 목록에 BOSS가 없을 경우 MO 상단 툴바의 \"실행 프로그램 등록\" 메뉴를 통해 BOSS를 등록하세요.")
            highlightItem("startGroup", false)
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("MO를 통해 BOSS를 실행시키면, 호환성을 최대로 살린 순서로 플러그인이 자동으로 재배열됩니다.\n사용자가 직접 배열한 순서는 무효화되므로, 만일을 위해 플러그인 배열 순서를 미리 백업해 두세요. 메인창의 백업 버튼 2개를 통해 각각 백업 저장/복구 가능합니다.\n또한 자동으로 BOSS 리포트가 열림으로써 클리닝 필요 여부나 호환성 문제 등을 참고할 수 있습니다. 새 모드를 설치했을 경우 BOSS 리포트를 꼭 읽어보세요.")
            waitForClick()
        },
        function() {
            unhighlight()
            tutorial.text = qsTr("마지막으로 다룰 충돌 유형은 \"레벨링 충돌 (Lists Conflicts)\"입니다.\n\"플러그인 충돌\"과 \"레벨링 충돌\" 모두 플러그인 사이에 동일한 ID 레코드로 발생하는 충돌이지만, 전자는 병합 불가능한 데 비해 후자는 병합 가능하다는 차이가 있습니다.\n\"레벨링 충돌\"의 경우에는 충돌하는 모드를 우선순위와 관계없이 모두 게임에 적용시킬 수 있습니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("\"레벨링 충돌\"의 가장 흔한 사례로는, 플레이어가 특정한 레벨에 도달했을 때 등장하는 물품/NPC의 레벨링 리스트를 들 수 있습니다.\n원래대로라면 동일한 레벨링 리스트가 여러개의 모드에 존재할 경우, 우선순위가 높은 모드 하나의 효과만 게임에 적용될 것입니다. 하지만 이를 바꿀 수 있는 프로그램이 존재합니다.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("Wyre Bash라는 멋진 프로그램을 통해 플러그인들의 레벨링 리스트를 병합함으로써, 충돌을 해결하고 모든 모드의 효과를 게임에서 즐길 수 있게 됩니다.\n(오블리비언/스카이림은 Wyre Bash, 폴아웃 3/nv는 Wyre Flash입니다. 스카이림의 경우 SkyBash도 있습니다)\n\n이 프로그램들은 모두 \"Bashed Patch (배쉬 패치)\"라는 이름의 새로운 플러그인을 만들어 줍니다. 이는 현재 활성화된 플러그인에 존재하는 레벨링 리스트가 병합된 파일이므로, Bashed Patch는 프로필마다 따로 만들어 주어야 합니다.\n\nWyre Bash는 MO 상단 툴바의 \"실행 프로그램 등록\" 메뉴를 통해 MO에 등록해서 실행시켜 주세요.")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("이것으로 충돌 튜토리얼을 모두 마칩니다.\n읽어주셔서 감사합니다.")
            waitForClick()
        }

    ]
}
