//TL First Steps#0
function getTutorialSteps()
{
  return [
    function() {
        tutorial.text = qsTr("모드 오거나이저 튜토리얼을 여신 것을 환영합니다!\n이 튜토리얼을 통해 MO의 가장 중요한 기능들에 대한 안내를 받으실 수 있습니다.")
        waitForClick()
    },

    function() {
        tutorial.text = qsTr("단계별 튜토리얼을 시작하기에 앞서, 튜토리얼 외에도 모드 오거나이저의 도움말을 참고할 수 있는 다른 방법들을 말씀드리고 싶습니다.")
        waitForClick()
    },

    function() {
        tutorial.text = qsTr("상단 툴바의 느낌표 버튼은 MO에서 자동으로 인식된 문제점들을 풀 수 있는 팁을 제공합니다.\n다음 단계로 넘어가려면 강조표시된 버튼을 클릭하세요.")
        if (!tutorialControl.waitForAction("actionProblems")) {
            highlightAction("actionProblems", false)
            waitForClick()
        } else {
            tutorial.text += qsTr("\n\n현재 문제점이 존재하고 있으나, 튜토리얼을 끝마칠 때까지는 잠시 기다려 주세요.")
            highlightAction("actionProblems", true)
        }
    },

    function() {
        tutorial.text = qsTr("상단 툴바의 물음표 버튼은 \"Tutorial\"(튜토리얼)과 \"Help on UI\"(인터페이스 도움말) 등의 다양한 정보를 제공합니다.")
        highlightItem("actionHelp", true)
        tutorialControl.waitForButton("actionHelp")
    },

    function() {
        tutorial.text = qsTr("마지막으로 MO의 거의 모든 부분에 툴팁 정보가 제공되고 있습니다.\n▶ 만약 MO 조작 중에서 잘 이해되지 않는 항목이 있다면, 항목 위에 마우스를 올리고 잠시 기다리면 \"툴팁\"으로 간단한 정보가 표시됩니다.\n▶ 혹은 마우스 우클릭해서 \"설명 보기\"가 뜰 경우, 보다 자세한 정보를 참고할 수 있습니다.\n▶ 또한 상단 툴바 물음표 버튼의 \"Help on UI\"(인터페이스 도움말)을 선택한 뒤 항목을 클릭해도 자세한 정보가 표시됩니다.")
        waitForClick()
    },

    function() {
        tutorial.text = qsTr("MO 메인창 왼쪽 패널에는 MO를 통해 설치된 모든 모드 목록이 표시됩니다. MO 사용시 첫번째 과제는 이 목록에 모드를 추가하는 것이 되겠지요.")
        highlightItem("modList", false)
        waitForClick()
    },

    function() {
        tutorial.text = qsTr("MO로 모드를 설치하는 방법에는 여러가지가 있습니다.\n▶ 먼저 상단 툴바의 \"환경 설정\" 버튼 - 문제해결 탭에서 넥서스 모드 매니저(NMM)를 최신 버전으로 설정하세요.\n▶ 그 다음 상단 툴바의 넥서스 버튼으로 넥서스 모드 페이지를 열어주세요. 이를 통해 MO는 NMM처럼 \"Download with Manager\" 녹색 버튼으로 다운로드 가능한 프로그램으로서 등록됩니다.")
        highlightAction("actionNexus", true)
        tutorialControl.waitForAction("actionNexus")
    },

    function() {
        tutorial.text = qsTr("넥서스에서 \"Download with Manager\" 버튼을 통해 다운로드한 자료는 이곳의 \"다운로드\" 탭에 나타납니다. 설치하려면 자료를 선택한 뒤 더블클릭하세요.")
        applicationWindow.modInstalled.connect(nextStep)
        highlightItem("downloadView", true)
    },

    function() {
        unhighlight()
        applicationWindow.modInstalled.disconnect(nextStep)
        tutorial.text = qsTr("훌륭합니다. 모드 설치가 잘 이루어졌습니다.\n설치 과정은 모드 자료가 구성된 방식에 따라 달라진다는 것을 참고하세요. 빠른 설치, Fomod 설치, 수동 설치 등의 다양한 설치 방법이 지원됩니다.")
        waitForClick()
    },

    function() {
        tutorial.text = qsTr("여기까지는 넥서스에서 직접 모드를 다운로드/설치하는 방법이었습니다.\n그밖에도 디스크에 저장된 자료를 직접 설치하는 것도 가능합니다. 상단 툴바 첫번째 버튼을 클릭하거나, 왼쪽 패널의 모드 목록에서 마우스 우클릭으로 \"모드 설치하기...\" 항목을 선택하시면 됩니다.")
        highlightAction("actionInstallMod", false)
        waitForClick()
    },

    function() {
        unhighlight()
        tutorial.text = qsTr("이제 모드 다운로드와 설치까지는 완료했으나, 모드를 실제로 게임에 적용시키기 위해서는 모드의 활성화 단계가 필요합니다.")
        waitForClick()
    },

    function() {
        tutorial.text = qsTr("원하실 경우 모드를 몇개 더 설치하신 뒤, 왼쪽 패널의 모드 목록에서 활성화시키고자 하는 모드에 체크하세요. 체크되지 않은 모드는 게임에 전혀 영향을 미치지 않습니다.")
        highlightItem("modList", true)
        modList.modlist_changed.connect(nextStep)
    },

    function() {
        modList.modlist_changed.disconnect(nextStep)
        unhighlight()
        tutorial.text = qsTr("몇몇 모드의 경우에는 왼쪽 패널에서 체크(활성화)하는 것만으로도 모드 적용이 완료됩니다.\n모드에 플러그인(esp/esm) 파일과 BSA 파일이 포함되어 있지 않은 모드가 그에 해당됩니다.")
        waitForClick()
    },

    function() {
        tutorial.text = qsTr("하지만 그밖의 대부분의 모드는 플러그인(esp/esm) 파일을 포함하고 있으며, 단순한 파일 대체가 아닌 무기/NPC/퀘스트/지역 등의 ID 값 레코드를 추가/변경하는 모드가 그에 해당됩니다.\n이러한 모드는 오른쪽 패널에서 플러그인 활성화 단계를 거쳐야 비로소 모드 적용이 완료됩니다.\n\n플러그인 목록을 확인하려면 \"Plugins\" 탭을 클릭하세요.")
        if (tutorialControl.waitForTabOpen("tabWidget", 0)) {
            highlightItem("tabWidget", true)
        } else {
            waitForClick()
        }
    },

    function() {
        tutorial.text = qsTr("플러그인 목록에서 몇몇 플러그인은 회색으로 표시되어 있을 것입니다. 이러한 플러그인은 게임 핵심 파일이므로 수동으로 비활성화할 수 없습니다.")
        waitForClick()
    },

    function() {
        tutorial.text = qsTr("모드 하나에 포함된 esp/esm 개수는 모드마다 차이가 있습니다. 어떤 모드는 0개인 데 비해, 다른 모드는 옵션 플러그인과 호환 패치까지 많은 플러그인을 포함하기도 합니다.\n왼쪽 패널의 모드 목록에서 해당 모드를 마우스 우클릭하고 \"모드 정보 보기...\"를 선택한 뒤, \"옵션 플러그인\" 탭으로 들어가면 자세한 정보를 확인할 수 있습니다.")
        highlightItem("modList", true)
        manager.activateTutorial("ModInfoDialog", "tutorial_firststeps_modinfo.js")
        applicationWindow.modInfoDisplayed.connect(nextStep)
    },

    function() {
        tutorial.text = qsTr("또다른 특수한 파일 유형으로 BSA가 있습니다. BSA는 여러가지 게임 자원을 하나로 묶은 파일입니다.\n오른쪽 패널의 \"Archives\" 탭을 클릭해 주세요.")
        if (tutorialControl.waitForTabOpen("tabWidget", 1)) {
            highlightItem("tabWidget", true)
        } else {
            waitForClick()
        }
    },

    function() {
        tutorial.text = qsTr("BSA는 루스 파일(묶이지 않은 파일)과 복잡하게 상호작용하기 때문에 설정이 어렵게 느껴지기 쉽습니다. 필요한 BSA가 체크(활성화)되지 않거나, 배열 순서가 잘못되었을 경우 게임 실행시 충돌이 발생하기도 합니다.")
        waitForClick()
    },

    function() {
        tutorial.text = qsTr("MO는 BSA와 루스 파일간의 순서를 조정하는 일종의 마법과 같은 기능을 갖고 있습니다.\n\"Archives\" 탭에서 체크(활성화)된 모든 BSA는 게임 기본 정책대로 루스 파일에 의해 무조건 덮어씌워지는 것이 아니라, 사용자가 설정한 순서 그대로 게임에 적용됩니다.\n대개 느낌표 표시가 뜬 BSA에는 모두 체크하는 것이 최선입니다.")
        waitForClick()
    },

    function() {
        tutorial.text = qsTr("이제 모드를 다운로드/설치/활성화하는 모든 단계를 완료했습니다.\n게임은 항상 MO를 통해 실행시켜야 한다는 것을 명심하세요. 그렇지 않으면 MO로 설치된 모드가 게임에 적용되지 않습니다.")
        highlightItem("startGroup", false)
        waitForClick()
    },

    function() {
        tutorial.text = qsTr("이 콤보박스에서는 MO를 통해 실행시킬 프로그램을 선택할 수 있습니다. 이 방법으로 게임, SKSE, CK툴, TES5Edit 등의 외부 프로그램을 MO 설치 모드가 모두 적용된 상태로 실행시킬 수 있게 됩니다.\n프로그램을 직접 추가하고자 할 경우, 이 콤보박스 혹은 상단 툴바의 나사 아이콘을 통해 원하는 프로그램을 등록/수정할 수 있습니다.")
        highlightItem("executablesListBox", false)
        waitForClick()
    },

    function() {
        tutorial.text = qsTr("이것으로 기본 튜토리얼을 마칩니다. 이제 모드를 설치하고 게임을 즐겨보세요!\n설치 모드 개수가 늘어나 충돌이 발생할 경우에는, 충돌 해결 튜토리얼(Conflict Resolution)을 참고하세요.")
        highlightItem("startButton", false)
        waitForClick()
    }
  ]
}
